
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>Redux异步方案选型 / iVAN</title>

    <meta name="description" content="Redux异步方案选型 作为react社区最热门的状态管理框架,相信很多人都准备甚至正在使用Redux. 由于Redux的理念非常精简,没有追求大而全,这份架构上的优雅却在某种程度上伤害了使用体验:不能开箱即用,甚至是异步这种最常见的场景也要借助社区方案. 如果你已经挑花了眼,或者正在挑但不知道是否适合,或者已经挑了但不知道会不会有坑,这篇文章应该适合你. 本文会从一些常见的Redux异步方案出发,介绍它们的优缺点,进而讨论一些与异步相伴的常见场景,帮助你在选型时更好地权衡利弊. 简单方案 redux-thunk:指路">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">Redux异步方案选型</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p>作为react社区最热门的状态管理框架，相信很多人都准备甚至正在使用Redux。</p>
<p>由于Redux的理念非常精简，没有追求大而全，这份架构上的优雅却在某种程度上伤害了使用体验：不能开箱即用，甚至是异步这种最常见的场景也要借助社区方案。</p>
<p>如果你已经挑花了眼，或者正在挑但不知道是否适合，或者已经挑了但不知道会不会有坑，这篇文章应该适合你。</p>
<p>本文会从一些常见的Redux异步方案出发，介绍它们的优缺点，进而讨论一些与异步相伴的常见场景，帮助你在选型时更好地权衡利弊。</p>
<p><strong>简单方案</strong></p>
<p>redux-thunk：指路先驱</p>
<p>Github：<a href="https://github.com/gaearon/redux-thunk" rel="external nofollow noreferrer">https://github.com/gaearon/redux-thunk</a></p>
<p>Redux作者Dan写的中间件，因官方文档出镜而广为人知。</p>
<p>它向我们展示了Redux处理异步的原理，即:</p>
<p>Redux本身只能处理同步的Action，但可以通过中间件来拦截处理其它类型的action，比如函数(Thunk)，再用回调触发普通Action，从而实现异步处理，在这点上所有Redux的异步方案都是类似的。</p>
<p>而它使用起来最大的问题，就是重复的模板代码太多：</p>
<pre>
</pre>
<ol>
<li>//action types </li>
<li>const GET_DATA = 'GET_DATA', </li>
<li>    GET_DATA_SUCCESS = 'GET_DATA_SUCCESS', </li>
<li>    GET_DATA_FAILED = 'GET_DATA_FAILED'; </li>
<li>     </li>
<li>//action creator </li>
<li>const getDataAction = function(id) { </li>
<li>    return function(dispatch, getState) { </li>
<li>        dispatch({ </li>
<li>            type: GET_DATA,  </li>
<li>            payload: id </li>
<li>        }) </li>
<li>        api.getData(id) //注：本文所有示例的api.getData都返回promise对象 </li>
<li>            .then(response =&gt; { </li>
<li>                dispatch({ </li>
<li>                    type: GET_DATA_SUCCESS, </li>
<li>                    payload: response </li>
<li>                }) </li>
<li>            }) </li>
<li>            .catch(error =&gt; { </li>
<li>                dispatch({ </li>
<li>                    type: GET_DATA_FAILED, </li>
<li>                    payload: error </li>
<li>                }) </li>
<li>            })  </li>
<li>    } </li>
<li>} </li>
<li> </li>
<li>//reducer </li>
<li>const reducer = function(oldState, action) { </li>
<li>    switch(action.type) { </li>
<li>    case GET_DATA :  </li>
<li>        return oldState; </li>
<li>    case GET_DATA_SUCCESS :  </li>
<li>        return successState; </li>
<li>    case GET_DATA_FAILED :  </li>
<li>        return errorState; </li>
<li>    } </li>
<li>}  </li>
</ol>
<p>这已经是最简单的场景了，请注意：我们甚至还没写一行业务逻辑，如果每个异步处理都像这样，重复且无意义的工作会变成明显的阻碍。</p>
<p>另一方面，像GET_DATA_SUCCESS、GET_DATA_FAILED这样的字符串声明也非常无趣且易错。</p>
<p>上例中，GET_DATA这个action并不是多数场景需要的，它涉及我们将会提到的乐观更新，保留这些代码是为了和下面的方案做对比</p>
<p><strong>redux-promise：瘦身过头</strong></p>
<p>由于redux-thunk写起来实在是太麻烦了，社区当然会有其它轮子出现。redux-promise则是其中比较知名的，同样也享受了官网出镜的待遇。</p>
<p>它自定义了一个middleware，当检测到有action的payload属性是Promise对象时，就会：</p>
<ul>
<li>若resolve，触发一个此action的拷贝，但payload为promise的value，并设status属性为"success"</li>
<li>若reject，触发一个此action的拷贝，但payload为promise的reason，并设status属性为"error"</li>
</ul>
<p>说起来可能有点不好理解，用代码感受下：</p>
<pre>
</pre>
<ol>
<li>//action types </li>
<li>const GET_DATA = 'GET_DATA'; </li>
<li> </li>
<li>//action creator </li>
<li>const getData = function(id) { </li>
<li>    return { </li>
<li>        type: GET_DATA, </li>
<li>        payload: api.getData(id) //payload为promise对象 </li>
<li>    } </li>
<li>} </li>
<li> </li>
<li>//reducer </li>
<li>function reducer(oldState, action) { </li>
<li>    switch(action.type) { </li>
<li>    case GET_DATA:  </li>
<li>        if (action.status === 'success') { </li>
<li>            return successState </li>
<li>        } else { </li>
<li>               return errorState </li>
<li>        } </li>
<li>    } </li>
<li>}  </li>
</ol>
<p>进步巨大! 代码量明显减少! 就用它了! ?</p>
<p>请等等，任何能明显减少代码量的方案，都应该小心它是否过度省略了什么东西，减肥是好事，减到骨头就残了。</p>
<p>redux-promise为了精简而做出的妥协非常明显：无法处理乐观更新</p>
<p><strong>场景解析之：乐观更新</strong></p>
<p>多数异步场景都是悲观更新(求更好的翻译)的，即等到请求成功才渲染数据。而与之相对的乐观更新，则是不等待请求成功，在发送请求的同时立即渲染数据。</p>
<p>最常见的例子就是微信等聊天工具，发送消息时消息立即进入了对话窗，如果发送失败的话，在消息旁边再作补充提示即可。这种交互"乐观"地相信请求会成功，因此称作乐观更新。</p>
<p>由于乐观更新发生在用户操作时，要处理它，意味着必须有action表示用户的初始动作</p>
<p>在上面redux-thunk的例子中，我们看到了GET_DATA,<br />
GET_DATA_SUCCESS、GET_DATA_FAILED三个action，分别表示初始动作、异步成功和异步失败，其中第一个action使得redux-thunk具备乐观更新的能力。</p>
<p>而在redux-promise中，最初触发的action被中间件拦截然后过滤掉了。原因很简单，redux认可的action对象是<br />
plain  JavaScript<br />
objects，即简单对象，而在redux-promise中，初始action的payload是个Promise。</p>
<p>另一方面，使用status而不是type来区分两个异步action也非常值得商榷，按照redux对action的定义以及社区的普遍实践，个人还是倾向于使用不同的type，用同一type下的不同status区分action额外增加了一套隐形的约定，甚至不符合该redux-promise作者自己所提倡的FSA，体现在代码上则是在switch-case内再增加一层判断。</p>
<p><strong>redux-promise-middleware：拔乱反正</strong></p>
<p>redux-promise-middleware相比redux-promise，采取了更为温和和渐进式的思路，保留了和redux-thunk类似的三个action。</p>
<p>示例：</p>
<pre>
</pre>
<ol>
<li>//action types </li>
<li>const GET_DATA = 'GET_DATA', </li>
<li>    GET_DATA_PENDING = 'GET_DATA_PENDING', </li>
<li>    GET_DATA_FULFILLED = 'GET_DATA_FULFILLED', </li>
<li>    GET_DATA_REJECTED = 'GET_DATA_REJECTED'; </li>
<li>     </li>
<li>//action creator </li>
<li>const getData = function(id) { </li>
<li>    return { </li>
<li>        type: GET_DATA, </li>
<li>        payload: { </li>
<li>            promise: api.getData(id), </li>
<li>            data: id </li>
<li>        } </li>
<li>    } </li>
<li>} </li>
<li> </li>
<li>//reducer </li>
<li>const reducer = function(oldState, action) { </li>
<li>    switch(action.type) { </li>
<li>    case GET_DATA_PENDING : </li>
<li>        return oldState; // 可通过action.payload.data获取id </li>
<li>    case GET_DATA_FULFILLED :  </li>
<li>        return successState; </li>
<li>    case GET_DATA_REJECTED :  </li>
<li>        return errorState; </li>
<li>    } </li>
<li>}  </li>
</ol>
<p>如果不需要乐观更新，action creator可以使用和redux-promise完全一样的，更简洁的写法，即：</p>
<pre>
</pre>
<ol>
<li>const getData = function(id) { </li>
<li>    return { </li>
<li>        type: GET_DATA, </li>
<li>        payload: api.getData(id) //等价于 {promise: api.getData(id)} </li>
<li>    } </li>
<li>}  </li>
</ol>
<p>此时初始actionGET_DATA_PENDING仍然会触发，但是payload为空。</p>
<p>相对redux-promise于粗暴地过滤掉整个初始action，redux-promise-middleware选择创建一个只过滤payload中的promise属性的XXX_PENDING作为初始action，以此保留乐观更新的能力。</p>
<p>同时在action的区分上，它选择了回归type的"正途"，_PENDING、_FULFILLED 、_REJECTED等后缀借用了promise规范  (当然它们是可配置的) 。</p>
<p>它的遗憾则是只在action层实现了简化，对reducer层则束手无策。另外，相比redux-thunk，它还多出了一个_PENDING的字符串模板代码(三个action却需要四个type)。</p>
<p>社区有类似type-to-reducer这样试图简化reducer的库。但由于reducer和异步action通常是两套独立的方案，reducer相关的库无法去猜测异步action的后缀是什么(甚至有没有后缀)，社区也没有相关标准，也就很难对异步做出精简和抽象了。</p>
<p><strong>redux-action-tools：软文预警</strong></p>
<p>无论是redux-thunk还是redux-promise-middleware，模板代码都是显而易见的，每次写XXX_COMPLETED这样的代码都觉得是在浪费生命——你得先在常量中声明它们，再在action中引用，然后是reducer，假设像redux-thunk一样每个异步action有三个type，三个文件加起来你就得写九次!</p>
<p>国外开发者也有相同的报怨：</p>
<p><a href="http://s5.51cto.com/wyfs02/M01/89/69/wKiom1gSBUHgxg7_AAIAZMPP-bI742.png-wh_651x-s_2988625237.png" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvczUuNTFjdG8uY29tL3d5ZnMwMi9NMDEvODkvNjkvd0tpb20xZ1NCVUhneGc3X0FBSUFaTVBQLWJJNzQyLnBuZy13aF82NTF4LXNfMjk4ODYyNTIzNy5wbmc=.jpg"></a></p>
<p>有没有办法让代码既像redux-promise一样简洁，又能保持乐观更新的能力呢?</p>
<pre>
</pre>
<ol>
<li>const GET_DATA = 'GET_DATA'; </li>
<li> </li>
<li>//action creator </li>
<li>const getData = createAsyncAction(GET_DATA, function(id) { </li>
<li>    return api.getData(id) </li>
<li>}) </li>
<li> </li>
<li>//reducer </li>
<li>const reducer = createReducer() </li>
<li>    .when(getData, (oldState, action) =&gt; oldState) </li>
<li>    .done((oldState, action) =&gt; successState) </li>
<li>    .failed((oldState, action) =&gt; errorState) </li>
<li>    .build()  </li>
</ol>
<p>redux-action-tools在action层面做的事情与前面几个库大同小异：同样是派发了三个action：GET_DATA/GET_DATA_SUCCESS/GET_DATA_FAILED。这三个action的描述见下表：</p>
<table>
<thead>
<tr>
<th>type</th>
<th>When</th>
<th>payload</th>
<th>meta.asyncPhase</th>
</tr>
</thead>
<tbody>
<tr>
<td><code>${actionName}</code></td>
<td>异步开始前</td>
<td>同步调用参数</td>
<td>'START'</td>
</tr>
<tr>
<td><code>${actionName}_COMPLETED</code></td>
<td>异步成功</td>
<td>value of promise</td>
<td>'COMPLETED'</td>
</tr>
<tr>
<td><code>${actionName}_FAILED</code></td>
<td>异步失败</td>
<td>reason of promise</td>
<td>'FAILED'<br />
 </td>
</tr>
</tbody>
</table>
<p>createAsyncAction参考了redux-promise作者写的redux-actions ，它接收三个参数，分别是：</p>
<ol>
<li>actionName 字符串，所有派生action的名字都以它为基础，初始action则与它同名</li>
<li>promiseCreator 函数，必须返回一个promise对象</li>
<li>metaCreator 函数，可选，作用后面会演示到</li>
</ol>
<p>目前看来，其实和redux-promise/redux-promise-middleware大同小异。而真正不同的，是它同时简化了reducer层!  这种简化来自于对异步行为从语义角度的抽象：</p>
<p>当(when)初始action发生时处理同步更新，若异步成功(done)则处理成功逻辑，若异步失败(failed)则处理失败逻辑</p>
<p>抽离出when/done/failed三个关键词作为api，并使用链式调用将他们串联起来：when函数接收两个参数：actionName和handler，其中handler是可选的，done和failed则只接收一个handler参数，并且只能在when之后调用——他们分别处理`${actionName}_SUCCESS`<br />
  和 `${actionName}_FAILED`.</p>
<p>无论是action还是reducer层，XX_SUCCESS/XX_FAILED相关的代码都被封装了起来，正如在例子中看到的——你甚至不需要声明它们!创建一个异步action，然后处理它的成功和失败情况，事情本该这么简单。</p>
<p>更进一步的，这三个action默认都根据当前所处的异步阶段，设置了不同的meta(见上表中的meta.asyncPhase)，它有什么用呢?用场景说话：</p>
<p><strong>场景解析：失败处理与Loading</strong></p>
<p>它们是异步不可回避的两个场景，几乎每个项目会遇到。</p>
<p>以异步请求的失败处理为例，每个项目通常都有一套比较通用的，适合多数场景的处理逻辑，比如弹窗提示。同时在一些特定场景下，又需要绕过通用逻辑进行单独处理，比如表单的异步校验。</p>
<p>而在实现通用处理逻辑时，常见的问题有以下几种：</p>
<p>1. 底层处理，扩展性不足</p>
<pre>
</pre>
<ol>
<li>function fetchWrapper(args) { </li>
<li>    return fetch.apply(fetch, args) </li>
<li>        .catch(commonErrorHandler) </li>
<li>}  </li>
</ol>
<p>在较底层封装ajax库可以轻松实现全局处理，但问题也非常明显：</p>
<p>一是扩展性不足，比如少数场景想要绕过通用处理逻辑，还有一些场景错误是前端生成而非直接来自于请求;</p>
<p>二是不易组合，比如有的场景一个action需要多个异步请求，但异常处理和loading是不需要重复的，因为用户不需要知道一个动作有多少个请求。</p>
<p>2. 不够内聚，侵入业务代码</p>
<pre>
</pre>
<ol>
<li>//action creator </li>
<li>const getData = createAsyncAction(GET_DATA, function(id) { </li>
<li>    return api.getData(id) </li>
<li>        .catch(commonErrorHandler) //调用错误处理函数 </li>
<li>})  </li>
</ol>
<p>在有业务意义的action层调用通用处理逻辑，既能按需调用，又不妨碍异步请求的组合。但由于通用处理往往适用于多数场景，这样写会导致业务代码变得冗余，因为几乎每个action都得这么写。</p>
<p>3. 高耦合，高风险</p>
<p>也有人把上面的方案做个依赖反转，改为在通用逻辑里监听业务action：</p>
<pre>
</pre>
<ol>
<li>function commonErrorReducer(oldState, action) { </li>
<li>    switch(action.type) { </li>
<li>    case GET_DATA_FAILED: </li>
<li>    case PUT_DATA_FAILED: </li>
<li>    //... tons of action type </li>
<li>        return commonErrorHandler(action) </li>
<li>    } </li>
<li>}  </li>
</ol>
<p>这样做的本质是把冗余从业务代码中拿出来集中管理。</p>
<p>问题在于每添加一个请求，都需要修改公共代码，把对应的action<br />
type加进来。且不说并行开发时merge冲突，如果加了一个异步action，但忘了往公共处理文件中添加——这是很可能会发生的——而异常是分支流程不容易被测试发现，等到发现，很可能就是事故而不是bug了。</p>
<p>通过以上几种常见方案的分析，我认为比较完善的错误处理(Loading同理)需要具备如下特点：</p>
<ul>
<li>面向异步动作(action)，而非直接面向请求</li>
<li>不侵入业务代码</li>
<li>默认使用通用处理逻辑，无需额外代码</li>
<li>可以绕过通用逻辑</li>
</ul>
<p>而借助redux-action-tools提供的meta.asyncPhase，可以轻易用middleware实现以上全部需求!</p>
<pre>
</pre>
<ol>
<li>import _ from 'lodash' </li>
<li>import { ASYNC_PHASES } from 'redux-action-tools' </li>
<li> </li>
<li>function errorMiddleWare({dispatch}) { </li>
<li>  return next =&gt; action =&gt; { </li>
<li>    const asyncStep = _.get(action, 'meta.asyncStep'); </li>
<li> </li>
<li>    if (asyncStep === ASYNC_PHASES.FAILED) { </li>
<li>      dispatch({ </li>
<li>        type: 'COMMON_ERROR', </li>
<li>        payload: { </li>
<li>          action </li>
<li>        } </li>
<li>      }) </li>
<li>    } </li>
<li>     </li>
<li>    next(action); </li>
<li>  } </li>
<li>}  </li>
</ol>
<p>以上中间件一旦检测到meta.asyncStep字段为FAILED的action便触发新的action去调用通用处理逻辑。面向action、不侵入业务、默认工作<br />
  (只要是用createAsyncAction声明的异步) !<br />
轻松实现了理想需求中的前三点，那如何定制呢?既然拦截是面向meta的，只要在创建action时支持对meta的自定义就行了，而createAsyncAction的第三个参数就是为此准备的：</p>
<pre>
</pre>
<ol>
<li>import _ from 'lodash' </li>
<li>import { ASYNC_PHASES } from 'redux-action-tools' </li>
<li> </li>
<li>const customizedAction = createAsyncAction( </li>
<li>  type,  </li>
<li>  promiseCreator, //type 和 promiseCreator此处无不同故省略 </li>
<li>  (payload, defaultMeta) =&gt; { </li>
<li>    return { ...defaultMeta, omitError: true }; //向meta中添加配置参数 </li>
<li>  } </li>
<li>) </li>
<li> </li>
<li>function errorMiddleWare({dispatch}) { </li>
<li>  return next =&gt; action =&gt; { </li>
<li>    const asyncStep = _.get(action, 'meta.asyncStep'); </li>
<li>    const omitError = _.get(action, 'meta.omitError'); //获取配置参数 </li>
<li> </li>
<li>    if (!omitError &amp;&amp; asyncStep === ASYNC_PHASES.FAILED) { </li>
<li>      dispatch({ </li>
<li>        type: 'COMMON_ERROR', </li>
<li>        payload: { </li>
<li>          action </li>
<li>        } </li>
<li>      }) </li>
<li>    } </li>
<li>     </li>
<li>    next(action); </li>
<li>  } </li>
<li>}  </li>
</ol>
<p>类似的，你可以想想如何处理Loading，需要强调的是建议尽量用增量配置的方式进行扩展，而不要轻易删除和修改meta.asyncPhase。</p>
<p>比如上例可以通过删除meta.asyncPhase实现同样功能，但如果同时还有其它地方也依赖meta.asyncPhase(比如loadingMiddleware)，就可能导致本意是定制错误处理，却改变了Loading的行为，客观来讲这层风险是基于meta拦截方案的最大缺点，然而相比多数场景的便利、健壮，个人认为特殊场景的风险是可以接受的，毕竟这些场景在整个开发测试流程容易获得更多关注。</p>
<p><strong>进阶方案</strong></p>
<p>上面所有的方案，都把异步请求这一动作放在了action  creator中，这样做的好处是简单直观，且和Flux社区一脉相承(见下图)。因此个人将它们归为相对简单的一类。</p>
<p><a href="http://s5.51cto.com/wyfs02/M02/89/66/wKioL1gSBhvCwpR_AAC8kodWEHU561.png" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvczUuNTFjdG8uY29tL3d5ZnMwMi9NMDIvODkvNjYvd0tpb0wxZ1NCaHZDd3BSX0FBQzhrb2RXRUhVNTYxLnBuZw==.jpg"></a></p>
<p>下面将要介绍的，是相对复杂一类，它们都采用了与上图不同的思路，去追求更优雅的架构、解决更复杂的问题</p>
<p><strong>redux-loop：分形! 组合!</strong></p>
<p>众所周知，Redux是借鉴自Elm的，然而在Elm中，异步的处理却并不是在action  creator层，而是在reducer(Elm中称update)层：</p>
<p><a href="http://s4.51cto.com/wyfs02/M01/89/66/wKioL1gSBi7A4S8IAAAq3vnnLbM059.png" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvczQuNTFjdG8uY29tL3d5ZnMwMi9NMDEvODkvNjYvd0tpb0wxZ1NCaTdBNFM4SUFBQXEzdm5uTGJNMDU5LnBuZw==.jpg"></a></p>
<p>图片来源于：<a href="https://github.com/jarvisaoieong/redux-architecture" rel="external nofollow noreferrer">https://github.com/jarvisaoie...</a></p>
<p>这样做的目的是为了实现彻底的可组合性(composable)。在redux中，reducer作为函数是可组合的，action正常情况下作为纯对象也是可组合的，然而一旦涉及异步，当action嵌套组合的时候，中间件就无法正常识别，这个问题让redux作者Dan也发出感叹<br />
  There is no easy way to compose Redux<br />
applications并且开了一个至今仍然open的issue，对组合、分形与redux的故事，有兴趣的朋友可以观摩以上链接，甚至了解一下Elm，篇幅所限，本文难以尽述。</p>
<p>而redux-loop，则是在这方面的一个尝试，它更彻底的模仿了Elm的模式：引入Effects的概念并将其置入reducer，官方示例如下：</p>
<pre>
</pre>
<ol>
<li>import { Effects, loop } from 'redux-loop'; </li>
<li>import { loadingStart, loadingSuccess, loadingFailure } from './actions'; </li>
<li> </li>
<li>export function fetchDetails(id) { </li>
<li>  return fetch(`/api/details/${id}`) </li>
<li>    .then((r) =&gt; r.json()) </li>
<li>    .then(loadingSuccess) </li>
<li>    .catch(loadingFailure); </li>
<li>} </li>
<li> </li>
<li>export default function reducer(state, action) { </li>
<li>  switch (action.type) { </li>
<li>    case 'LOADING_START': </li>
<li>      return loop( </li>
<li>        { ...state, loading: true }, </li>
<li>        Effects.promise(fetchDetails, action.payload.id) </li>
<li>      ); // 同时返回状态与副作用 </li>
<li> </li>
<li>    case 'LOADING_SUCCESS': </li>
<li>      return { </li>
<li>        ...state, </li>
<li>        loading: false, </li>
<li>        details: action.payload </li>
<li>      }; </li>
<li> </li>
<li>    case 'LOADING_FAILURE': </li>
<li>      return { </li>
<li>        ...state, </li>
<li>        loading: false, </li>
<li>        error: action.payload.message </li>
<li>      }; </li>
<li> </li>
<li>    default: </li>
<li>      return state; </li>
<li>  } </li>
<li>}  </li>
</ol>
<p>注意在reducer中，当处理LOADING_START时，并没有直接返回state对象，而是用loop函数将state和Effect"打包"返回(实际上这个返回值是数组[State,  Effect]，和Elm的方式非常接近)。</p>
<p>然而修改reducer的返回类型显然是比较暴力的做法，除非Redux官方出面，否则很难获得社区的广泛认同。更复杂的返回类型会让很多已有的API，三方库面临危险，甚至combineReducer都需要用redux-loop提供的定制版本，这种"破坏性"也是Redux作者Dan没有采纳redux-loop进入Redux核心代码的原因："If<br />
  a solution doesn’t work with vanilla combineReducers(), it won’t get<br />
into Redux  core"。</p>
<p>对Elm的分形架构有了解，想在Redux上继续实践的人来说，redux-loop是很好的参考素材，但对多数人和项目而言，最好还是更谨慎地看待。</p>
<p><strong>redux-saga：难、而美</strong></p>
<p>Github: <a href="https://github.com/yelouafi/redux-saga" rel="external nofollow noreferrer">https://github.com/yelouafi/r...</a></p>
<p>另一个著名的库，它让异步行为成为架构中独立的一层(称为saga)，既不在action creator中，也不和reducer沾边。</p>
<p>它的出发点是把副作用 (Side effect，异步行为就是典型的副作用)  看成"线程"，可以通过普通的action去触发它，当副作用完成时也会触发action作为输出。</p>
<pre>
</pre>
<ol>
<li>import { takeEvery } from 'redux-saga' </li>
<li>import { call, put } from 'redux-saga/effects' </li>
<li>import Api from '...' </li>
<li> </li>
<li>function* getData(action) { </li>
<li>   try { </li>
<li>      const response = yield call(api.getData, action.payload.id); </li>
<li>      yield put({type: "GET_DATA_SUCCEEDED", payload: response}); </li>
<li>   } catch (e) { </li>
<li>      yield put({type: "GET_DATA_FAILED", payload: error}); </li>
<li>   } </li>
<li>} </li>
<li> </li>
<li>function* mySaga() { </li>
<li>  yield* takeEvery("GET_DATA", getData); </li>
<li>} </li>
<li> </li>
<li>export default mySaga;  </li>
</ol>
<p>相比action  creator的方案，它可以保证组件触发的action是纯对象，因此至少在项目范围内(middleware和saga都是项目的顶层依赖，跨项目无法保证)，action的组合性明显更加优秀。</p>
<p>而它最为主打的，则是可测试性和强大的异步流程控制。</p>
<p>由于强制所有saga都必须是generator函数，借助generator的next接口，可以轻易对异步行为的每个中间步骤做mock，实现对异步逻辑"step<br />
  by step"的测试，这在其它方案中是很少看到的 (当然也可以借鉴generator这一点，但缺少约束)。</p>
<p>而强大得有点眼花缭乱的API，特别是channel的引入，则提供了武装到牙齿级的异步流程控制能力。</p>
<p>然而，回顾我们在讨论简单方案时提到的各种场景与问题，redux-saga并没有去尝试回答和解决它们，这意味着你需要自行寻找解决方案。而generator、相对复杂的API和单独的一层抽象也让不少人望而却步。</p>
<p>包括我在内，很多人非常欣赏redux-saga。它的架构和思路毫无疑问是优秀甚至优雅的，但使用它之前，最好想清楚它带来的优点(可测试性、流程控制、高度解耦)与付出的成本是否匹配，特别是异步方面复杂度并不高的项目，比如多数以CRUD为主的管理系统。</p>
<p><strong>小结</strong></p>
<p>本文包含了一些redux社区著名、非著名 (恩，我的redux-action-tools) 的异步方案，这些其实并不重要。</p>
<p>因为方案是一家之作，结论也是一家之言，不可能放之四海皆准。个人更希望文中探讨过的常见问题和场景，比如模板代码、乐观更新、错误处理等，能够成为你选型时的尺子，为你的权衡提供更好的参考，而不是等到项目热火朝天的时候，才发现当初选型的硬伤。</p>
<p>作者：kpaxqin</p>
<p>来源：51CTO</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-03-29 17:52:27</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/%e5%87%bd%e6%95%b0/" title="函数">函数</a>, <a href="https://www.iamivan.net/tag/type/" title="type">type</a>, <a href="https://www.iamivan.net/tag/%e4%b8%ad%e9%97%b4%e4%bb%b6/" title="中间件">中间件</a>, <a href="https://www.iamivan.net/tag/redux/" title="redux">redux</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>Redux异步方案选型的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pn759Zz.html" rel="bookmark">&lbrack;译&rsqb; Redux 异步四兄弟</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本文讲的是[译] Redux 异步四兄弟, 原文地址:Redux 4 Ways 原文作者:本篇文章已获得作者 Nader Dabit 授权 译文出自:掘金翻译计划 译者:reid3290 校对者:rccoder,xekri 在十分钟内实践 Thunk . Saga . Observable 以及 Redux Promise Middleware. 在上一次的 React Native online meetup 活动中,笔者就 Thunk . Saga 以及 Redux Observable 之			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/p5O2xWb.html" rel="bookmark">零售ERP系统方案选型&horbar;IT只是一个工具</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本文讲的是零售ERP系统方案选型―IT只是一个工具, IT是一个相当理性的领域,在这个领域的空气中,充斥着理性和逻辑的氧分子,几乎所有人都认为.对IT产品的选择,要基于可靠的性能.铁心的服务.最优的性价比等客观因素,事实当然也确实如此.     反观国内众多零售企业的大佬,对于IT有一种常识性的误区.认为一上信息化,则企业内部的许多管理.销售.营销.财务.营运等等问题都迎刃而解,这种倾向随着ERP(企业资源计划)这个词汇和概念的炒作,似乎越演越烈:无论是媒体.无论是培训班.无论是研讨会:每每一讲			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M6A3eAb.html" rel="bookmark">MySQL高可用方案选型参考</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本文由「MySQL中文网」原创,&quot;MySQL中文&quot;公众号是 http://imysql.com 的官方唯一公众号,微信首发. 欢迎关注「MySQL中文」公众号(ID: imysql_wx),我们会不定期推送MySQL相关原创干货. 本次专题是 MySQL高可用方案选型,这个专题想必有很多同学感兴趣. 高可用的意义以及各种不同高可用等级相应的停机时间我就不必多说了,直接进入主题. 可选MySQL高可用方案 MySQL的各种高可用方案,大多是基于以下几种基础来部署的: 基于主从复制: 基于			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/p8Ak9Nz.html" rel="bookmark">10款常见MySQL高可用方案选型解读</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				作者介绍 王松磊,现任职于UCloud,从事MySQL数据库内核研发工作.主要负责UCloud云数据库udb的内核故障排查工作以及数据库新特性的研发工作.   一.概述   我们在考虑MySQL数据库的高可用架构时,主要考虑如下几方面:   如果数据库发生了宕机或者意外中断等故障,能尽快恢复数据库的可用性,尽可能的减少停机时间,保证业务不会因为数据库的故障而中断. 用作备份.只读副本等功能的非主节点的数据应该和主节点的数据实时或者最终保持一致. 当业务发生数据库切换时,切换前后的数据库内容应当一			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MqD6AZb.html" rel="bookmark">JavaScript 异步方案 async&sol;await 实例教程</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				构建一个应用程序总是会面对异步调用,不论是在 Web 前端界面,还是 Node.js 服务端都是如此, JavaScript 里面处理异步调用一直是非常恶心的一件事情.以前只能通过回调函数,后来渐渐又演化出来很多方案,最后 Promise 以简单.易用.兼容性好取胜,但是仍然有非常多的问题.其实 JavaScript 一直想在语言层面彻底解决这个问题,在 ES6 中就已经支持原生的 Promise ,还引入了 Generator 函数,终于在 ES7 中决定支持 async 和 await .			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pmB19Bz.html" rel="bookmark">需求至上&mdash;&mdash;MongoDB多数据中心的方案选型</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Teambition业务本身是为了了更好的团队协作,并且随着用户量和使用⾏业.企业的增加,越来越多的跨国协作需求体现出来.对TB的选型来说,目的就是多region(大陆/海外)来提供服务,逐步扩大市场.总结而言,是业务的需要.   Single-Cluster or Multi-Cluster ? • 单集群还是多集群的选择往往受到业务本身,以及希望实现什么样的多数据中心架构影响 • 是否需要所谓的多primary写入   Replsettag or Shardtagrange ? • 数据库集			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MraL31b.html" rel="bookmark">中小企业OA系统方案选型六个误区</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				近些年来,企业信息化建设迅速发展,OA软件迅速普及,媒体和厂商都在大力宣传,各种概念.观点.产品纷至沓来.国内很多企业实施了OA项目,相关产品也应接不暇,但在选与被选之间总有诸多&quot;不对称&quot;,以致背道而驰,难于&quot;双赢&quot;.那么企业如何正确认识OA?在OA选型中存在哪些误区? 误区一.OA就是行政办公,对政府机关有价值,但对企业价值不大 在OA刚刚出现的时候,政府和事业单位的确是OA的主要用户,OA还没有进入企业.所以人们认为OA并不能解决企业管理层关心和控制企业运营过程			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/b3JgDWz.html" rel="bookmark">【转】保证分布式系统数据一致性的6种方案</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题的起源 在电商等业务中,系统一般由多个独立的服务组成,如何解决分布式调用时候数据的一致性? 具体业务场景如下,比如一个业务操作,如果同时调用服务 A.B.C,需要满足要么同时成功:要么同时失败.A.B.C 可能是多个不同部门开发.部署在不同服务器上的远程服务. 在分布式系统来说,如果不想牺牲一致性,CAP 理论告诉我们只能放弃可用性,这显然不能接受.为了便于讨论问题,先简单介绍下数据一致性的基础理论. 强一致   当更新操作完成之后,任何多个后续进程或者线程的访问都会返回最新的更新过的值.这			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/jbEddLz.html" rel="bookmark">JS异步传递数组Action接受的实现与疑惑</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				最近开发中遇到了页面传递数组到Action后台List类型,接受到的list对象并不是想象的按照数组元素位置对应的接受,例如数组的0位置插入到list对象的0位置, 而是数组的全部内容全部插入到了list集合的第一位置.经过反复的试验,没有找到很好的解决办法,只能把这种粗糙的实现方式记录下来,以求抛砖引玉望大家能给出更好的实现方式. 这是jsp页面代码:异步提交数组到Action中: &lt;html&gt; &lt;head&gt; &lt;meta http-equiv=&quot;Content-T			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/VzwWXdz.html" rel="bookmark" class="title">图像平均及其在降噪方面的应用</a>
					<div>
						图像平均及其在降噪方面的应用 图像平均以及图像平均在应对椒盐/高斯/相机噪声方面的对比分析 概述: 图像平均操作是减少图像噪声的一种简单方式. 我们可以简单地从图像列表中计算出一幅平均图像. 假设所有 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/0zGwBkz.html" rel="bookmark" class="title">ASP数据库被挂马的编程处理方法</a>
					<div>
						数据库被挂马我相信很多人都碰到过.在这里,我讲下我处理的方法.     第一步:为现有数据库做好备份.     第二步:执行如下ASP文件,这样就可以去掉数据库当中的JS木马:     注:conn. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/5zOdW9b.html" rel="bookmark" class="title">早期起源</a>
					<div>
						  正则表达式的&quot;祖先&quot;可以一直上溯至对人类神经系统如何工作的早期研究.Warren McCulloch 和 Walter Pitts 这两位神经生理学家研究出一种数学方式来描述这 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/6b3a2Wp.html" rel="bookmark" class="title">网页设计资源&colon;WEBJX网页设计丝带元素优秀案例</a>
					<div>
						文章描述:丝带元素在网页设计中应用的32个优秀案例. 在网页设计中,丝带(Ribbon)元素主要用于在导航和标题区,可以帮助网站塑造出一种古典老式的风格.网页设计的形式在不断更新发展,而丝带却在网页设 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Xpmo5ab.html" rel="bookmark" class="title">帮助文件里AS做滤镜效果的类整理</a>
					<div>
						滤镜 用as做滤镜效果,每种滤镜效果对应一个类,这些类都在Macromedia\Flash 8 Beta 2\zh_cn\First Run\Classes\FP8\flash\filters这个文件 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/7M0oWDb.html" rel="bookmark" class="title">刘玉刚：快速增加网站外链方法之我见</a>
					<div>
						自从在A5学习了大半年的时候后,多次看到一些高手们强调外调的重用有多么多么重要后,一语惊醒梦中人,从此由我负责的粽子网便开始了一轮新的革命--增加外链.说到外链可能很多站长首先想到的是友情链接,但自己 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M1RrO8p.html" rel="bookmark" class="title">windows server 2008 R2&sol;windows 7管理二十八 Mail之基本使用</a>
					<div>
						上篇我们已经安装好了exchange2010,呵呵本片简单介绍和看下ex2010的基本界面和使用 安装完成打开exchange控制台如图所示 汗,有试用限制,4个月的评估版,基本界面看起来跟2007并 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bEln1Az.html" rel="bookmark" class="title">log4j的配制及测试程序</a>
					<div>
						1,写个初始化的SERVLET: package net.welovetennis.util.log; import javax.servlet.*; import javax.servlet.htt ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bK7Ng5b.html" rel="bookmark" class="title">Photoshop调出草地美女照片流行的暗调暖色</a>
					<div>
						图片背景草地颜色有点单一,处理的适合可以适当加入鲜艳一点的橙黄色,颜色不要太亮,主基调为暗调暖色.暗部可以加入一些简单的冷色,如蓝色.蓝紫色等. 原图 &lt;点小图查看大图&gt; 最终效果 &lt ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pPND98b.html" rel="bookmark" class="title">360创始人周鸿祎：什么是好的用户体验？</a>
					<div>
						说今天是一个体验为王的时代,一点也不过分. 做大众消费品的人可能已经感觉到,今天消费者的话语权越来越强,如果你的产品做得好,不久就会口口相传;如果你的产品做得烂,不久就会骂声一片.所有这一切在过去是不 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zGJrBOp.html" rel="bookmark" class="title">Excel的Hour函数是什么</a>
					<div>
						  Excel的Hour函数返回一个 Variant (Integer),其值为 0 到 23 之间的整数,表示一天之中的某一钟点. 语法 Hour(time) 必要的 time 参数,可以是任何能够 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zOaQQkM.html" rel="bookmark" class="title">如何解决打印机无法打印、该文档未能打印的问题</a>
					<div>
						  打印机无法打印的症状和解决方法: 第一种症状:该文档未能打印;在任务栏的右下角出现黄色感叹号并提示&quot;该文档未能打印&quot;.USB打印机的USB链接线断裂.接触不良和打印机驱动不正常 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zJZWV2z.html" rel="bookmark" class="title">QT中的小问题汇集</a>
					<div>
						1QT中使用路径的方法: 绝对路径 采用C:/dir/a.jpg的方法 相对路径 采用../../temp/a.jpg的方法,其中用../表示上一级用/表示当前目录下 另外可以通过qapplicati ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p8ZnDxb.html" rel="bookmark" class="title">&lbrack;Qt教程&rsqb; 第46篇 进阶（六） 国际化</a>
					<div>
						[Qt教程] 第46篇 进阶(六) 国际化 楼主  发表于 2013-10-7 09:23:45 | 查看: 109| 回复: 0 国际化 版权声明 该文章原创于Qter开源社区 导语 在第2篇中讲述 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zDWdP6p.html" rel="bookmark" class="title">如何使用php绘制在图片上的正余弦曲线&lowbar;php技巧</a>
					<div>
						以前用actionscript写动态绘制三角函数曲线,其实php输出三角函数曲线也很简单. 复制代码 代码如下: &lt;?php define(&quot;MAX_WIDTH_PIXEL&quot; ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MxoWBmb.html" rel="bookmark" class="title">在一个html中调用两个javascript为什么不能同时运行。。急！！</a>
					<div>
						问题描述 在一个html中调用两个javascript为什么不能同时运行..急!! &lt;script src=&quot;script01.js&quot;&gt;&lt;/script&gt;  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z7YLk5M.html" rel="bookmark" class="title">如何实现xml中的数据合并</a>
					<div>
						问题描述 如何实现xml中的数据合并 如图片所示: 在同一个pdbid的情况下(如:pdbid=&quot;1A1R&quot;), 因为第3行的 ID=AC ,和第11行的 ID=CA 反序, 那么 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zJkyl7b.html" rel="bookmark" class="title">《C语言程序设计》一 2&period;1　案例引入&mdash;&mdash;计算三角形的面积</a>
					<div>
						2.1 案例引入--计算三角形的面积 程序prg1-3.c只能计算边长为3.4.5的三角形的面积,不具有通用性.修改该程序,使其可以计算任意三角形的面积. [例2-1] 输入三角形三边,计算三角形的面 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MqA432M.html" rel="bookmark" class="title">阿里移动电商背后的技术航母</a>
					<div>
						2015天猫双11 全球狂欢节刚刚结束,912亿的全天成交额再次刷新了记录,其中无线占比68.67%,无线交易额高达626亿.   美国时间11月16日,InfoQ英文站邀请到了阿里无线事业部资深技术 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/boKAAjb.html" rel="bookmark" class="title">全部破解100&percnt;能用的龙族系列软件&lowbar;常用工具</a>
					<div>
						系列软件全部已破通用注册信息(02.25更新) 终极Flash播放器 V1.79(2007年02月25日发布)*-价值30元 http://www1.skycn.com/soft/27771.html ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zeRO58b.html" rel="bookmark" class="title">空间索引&lpar;GiST、BRIN、R-Tree&rpar;选择、优化 - 阿里云RDS PostgreSQL最佳实践</a>
					<div>
						标签 PostgreSQL , Greenplum , PostGIS , GiST , R-Tree , BRIN , 相关性 , 网格 , BOX , K-Mean 背景 空间数据的搜索需求通常包 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b3rLE7z.html" rel="bookmark" class="title">Apache Kafka源码分析 &ndash; Broker Server</a>
					<div>
						1. Kafka.scala 在Kafka的main入口中startup KafkaServerStartable, 而KafkaServerStartable这是对KafkaServer的封装 1: ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MY5xNxM.html" rel="bookmark" class="title">汉信码应用推广新闻发布会在京举行</a>
					<div>
						12月16日,由中国物品编码中心主办的汉信码应用推广新闻发布会在京举行.会上,中国物品编码中心宣布与百度达成战略合作.双方的合作点主要展现在三个方面:一是商品条码的扫描,二是梦幻汉信码,三是百度助力汉 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MrXRAxz.html" rel="bookmark" class="title">qt android startActviy怎么启动带android系统URI的intent</a>
					<div>
						问题描述 qt android startActviy怎么启动带android系统URI的intent 我想用qt android 的 startActivity启动一个这样的intent(Inten ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mvn5E6M.html" rel="bookmark" class="title">&lbrack;转&rsqb;网页栅格系统研究（2）：蛋糕的切法</a>
					<div>
						[出自]http://lifesinger.org/blog/2008/10/grid-system-2/ 首先澄清一个应用场景问题.研究(1)中指出,对于结构复杂的网站,不少设计师们喜欢采用960固 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M601POz.html" rel="bookmark" class="title">菜鸟求助一个JSP错误</a>
					<div>
						问题描述 HTTPStatus500---------------------------------------------------------------------------------t ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bEYlmLb.html" rel="bookmark" class="title">邵晓峰：Ebay失败是因为脱离了群众</a>
					<div>
						中介交易 http://www.aliyun.com/zixun/aggregation/6858.html&quot;&gt;SEO诊断 淘宝客 云主机 技术大厅 PConline北京7月27日[文 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bBkY9NM.html" rel="bookmark" class="title">Android编程之内存溢出解决方案（OOM）实例总结&lowbar;Android</a>
					<div>
						本文实例总结了Android编程之内存溢出解决方案(OOM).分享给大家供大家参考,具体如下: 在最近做的工程中发现加载的图片太多或图片过大时经常出现OOM问题,找网上资料也提供了很多方法,但自己感觉 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MgEQX1z.html" rel="bookmark" class="title">Java 8中简单Lambda表达式实例程序教程</a>
					<div>
						我尝试过把Lambda表达式融入到我的代码中,下面的代码例子是此次尝试的结果.对于那些完全不知道Lambda表达式的Java程序员,我强烈建议在继续阅读之前,浏览一下这篇文章. Ok,现在你已经熟悉L ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MNvQP7M.html" rel="bookmark" class="title">C&sol;C&plus;&plus;编译器GCC下的常用编译命令总结&lowbar;C 语言</a>
					<div>
						简介GCC的意思是GUN C Compiler.经过了多年的发展,GCC已经不仅仅能支持C语言了,它现在还支持Ada语言.C++语言.Java语言.Objective C语言.Pascal语言.COB ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 12 q. 0.047 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
